#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )


void func_a(int8_t sel) {
	if (sel) {
#if defined (__AVR_ATtiny2313__)
		bit_set(DDRB, PB0);
		bit_set(PORTB, PB0);
#else
		bit_set(DDRC, PC0);
		bit_set(PORTC, PC0);
#endif
	} else {
#if defined (__AVR_ATtiny2313__)
		bit_clear(PORTB, PB0);
		bit_clear(DDRB, PB0);
#else
		bit_clear(PORTC, PC0);
		bit_clear(DDRC, PC0);
#endif
	}
}

void (*func)(int8_t) = func_a;

int main() {
	int8_t i;
//	char *p = (PSTR("abc") + 0x4000);
	char *p = "abc";
#if 1
	for (i=0; i<3; i++) {
		func_a(i);
	}
#else
	for (i=0; i<100; i++) {
		func_a(i & 1);
	}
#endif
	func = func_a;
	while (*p) {
#if defined (__AVR_ATtiny2313__)
		PORTB = *p;
#else
		PORTC = *p;
#endif
		p++;
	}
	return 0;
}
